#pragma once
#include "olcPixelGameEngine.h"

class FiestaOnlineEditor;

class Window{
private:
	vi2d pos;
	Decal*decWindow;
	bool dragging=false;
	vf2d dragPoint;
	bool canClose=false;
	bool closed=false;
protected:
	const int headerHeight=12;
	vi2d size;
	Sprite*sprWindow;
	static Window*focusedWindow;
	std::string windowTitle="";
	vf2d GetPos(); //Note this isn't the actual window's position, it's the drawable window position.
public:
	Window(FiestaOnlineEditor*pge,std::string windowTitle,vi2d pos,vi2d size);
	virtual ~Window();
	void InternalUpdate(FiestaOnlineEditor*pge,float fElapsedTime);
	virtual void Update(FiestaOnlineEditor*pge,float fElapsedTime)=0;
	virtual void Refresh(FiestaOnlineEditor*pge)=0;
	void InternalRefresh(FiestaOnlineEditor*pge);
	void Draw(FiestaOnlineEditor*pge);
	bool IsFocusedWindow();
	static void SetFocusedWindow(FiestaOnlineEditor*pge,Window*w);
	void Cleanup();
	bool IsInBounds(vf2d point);
	void InternalMouseFocus(FiestaOnlineEditor*pge);
	virtual void MouseFocus(FiestaOnlineEditor*pge);
	bool IsClosed();
};